#!/usr/bin/perl

use CGI;
# uncomment the following if you are debugging
#use CGI::Carp qw(fatalsToBrowser);

$CGI::POST_MAX = 300;
$CGI::DISABLE_UPLOADS = 1;

#----------------------------------------------------------------
# it is very important that this BEGIN block come before
# "use AbsenceConfig;" below.  The INSTANCE_NAME environment
# variable must be defined before AbsenceConfig is loaded.
#----------------------------------------------------------------
BEGIN {
	if ($ENV{QUERY_STRING} =~ /^instance=(\S+)$/) {
		# an instance has been specified
		$ENV{INSTANCE_NAME} = $1;
		$cookie_name = "absence-$1";
	} else {
		$cookie_name = 'absence';
	}
}

use AbsenceConfig;
use AbsenceImage;
use AbsenceLog;

$IMAGE_DIR_ABS	= AbsenceConfig::fetch('image_dir_abs');
$DATA_REL		= AbsenceConfig::fetch('data_dir_rel');
$CGI_DIR		= AbsenceConfig::fetch('cgi_dir_rel');
$MAP_TYPE		= AbsenceConfig::fetch('map_type');
$COOKIE_DOMAIN	= AbsenceConfig::fetch('cookie_domain');
$DEBUG			= 0;
$DEF_MONTHS		= 6;
$VERSION		= '1.3';

#=================================================================
# main
#=================================================================

($month, $year) = (localtime)[4,5];
$month++;
$year += 1900;

$q = new CGI;
$q->import_names;

%cookie = $q->cookie($cookie_name);

$chunk_mult	= 0;
$chunksize	= $DEF_MONTHS;

$cd = "cookie debugging...<BR>\n";

if (exists($cookie{mult})) {
	$chunk_mult = $cookie{mult};
	$cd .= "cookie: MULT = $chunk_mult<BR>\n";
}

if (exists($cookie{chunksize})) {
	$chunksize = $cookie{chunksize};
	$cd .= "cookie: CHUNKSIZE = $chunksize<BR>\n";
}

if (exists($cookie{month})) {
	$month = $cookie{month};
	$year = $cookie{year};
	$cd .= "cookie: MONTH = $month, YEAR = $year<BR>\n";
}

if (exists($cookie{group_id})) {
	$group_id = $cookie{group_id};
	if (!AbsenceDB::groupExists($group_id)) {
		$cd .= "group_id [$group_id] disappeared, erasing.\n";
		$group_id = undef;
	}
	$cd .= "cookie: GROUP_ID = $group_id<BR>\n";
}

$DEBUG && abslog("action = [$Q::action]");

# if $Q::start_month is set, I know that a submit() took place

if (($Q::start_month) || ($Q::jump =~ /^(Next|Previous)/)) {
	$year		= $q->param('start_year');
	$month		= $q->param('start_month');
	$chunksize	= $q->param('chunksize');
	$group_id	= $q->param('group_id');
}

if ($Q::jump =~ /^Next/) {
	if (!%cookie) {
		print $q->header, $q->start_html('Absence');
		print $q->h1('The <EM>Next</EM> button will not work without cookies.');
		print $q->end_html;
		exit;
	}
	$chunk_mult++;
	$cd .= "must increment. now mult = $chunk_mult<BR>\n";
} elsif ($Q::jump =~ /^Previous/) {
	if (!%cookie) {
		print $q->header, $q->start_html('Absence');
		print $q->h1('The <EM>Previous</EM> button will not work without cookies.');
		print $q->end_html;
		exit;
	}
	$chunk_mult--;
	$cd .= "must decrement. now mult = $chunk_mult<BR>\n";
} elsif ($Q::start_month) {
	$chunk_mult = 0;
	$cookie{month} = $month;
	$cookie{year} = $year;
} elsif ($Q::action eq '') {
	$chunk_mult = 0;
}

#-------------------------------------------------------------
# always set cookie
#-------------------------------------------------------------

$cookie{chunksize} = $chunksize;
$cookie{mult} = $chunk_mult;
$cookie{group_id} = $group_id;
$cookie = $q->cookie(
	-name	=> $cookie_name,
	-value	=> \%cookie,
	-path	=> '/',
	-domain	=> $COOKIE_DOMAIN,
	-expires=> '+10y',
);

# for debugging
#abslog("setting cookie:\n\tname=$cookie_name\n\tchunksize=$cookie{chunksize}\n\tmult=$cookie{mult}\n\tgid=$cookie{group_id}");

if ($chunk_mult != 0) {
	($month, $year) = moveByChunk($month, $year, $chunk_mult, $chunksize);
}

@cookies = (-cookie => $cookie);

print $q->header(-expires => '-1d', @cookies),
	$q->start_html(
		-title		=> 'Absence',
		-BGCOLOR	=> '#44b49a',
		#-BGCOLOR	=> '#917b0c',
		#-BGCOLOR	=> '#722121',
		#-BGCOLOR	=> '#172872',
	);

$DEBUG && print "$cd";

if (!length($group_id)) {
	print $q->h1('Select Group Above');
	print $q->end_html;
	exit;
}

#print $q->h1('Absences for group FOOBAR');

#print "DOCUMENT_ROOT = [$ENV{DOCUMENT_ROOT}]<BR>\n";
# debug
if ($DEBUG) {
	@keywords = $q->keywords;
	@names = $q->param;

	print "Parameters:<BR>\n";
	foreach $p (@names) {
		print " [$p] ".$q->param($p)."<BR>\n";
	}

	print "<P>Keywords:<BR>\n";
	foreach $p (@keywords) {
		print " [$p]<BR>\n";
	}

	if ($cookie{chunksize}) {
		print "CHUNKSIZE: [$chunksize]<BR>\n";
	}
	print "chunk_mult = [$chunk_mult]<BR>\n";
}

#print "<P>(see <A HREF=\"${DATA_REL}/absence-help.html\">here</A> for instructions)<BR>\n";

my $it = AbsenceConfig::fetch('image_type');
$legend = "$IMAGE_DIR_ABS/legend.$it";
AbsenceImage::makeLegend($legend);

print "<IMG BORDER=2 SRC=\"${DATA_REL}/img/legend.$it\"></A>\n";
print qq[(see <A HREF="${DATA_REL}/absence-help.html">here</A> for instructions)<BR>\n];


$count = 0;
my ($width, $height);
my $inst;
if (exists($ENV{INSTANCE_NAME})) { $inst = "/in=$ENV{INSTANCE_NAME}"; }
while($count < $chunksize) {
	$fn = "absence-${group_id}-${month}-${year}.$it";
	$out = "$IMAGE_DIR_ABS/$fn";
	$in = "${DATA_REL}/img/$fn";
	if (! -e $out || imageOlder($out, $group_id, $month, $year)) {
		#print "-creating $out -<BR>\n";
		#print "<!-- creating [$out] -->\n";
		AbsenceImage::create($month, $year, $group_id, $out);
	}
	if (!$count) {
		($width, $height) = AbsenceImage::dimensions($month, $year, $group_id);
	}
	$modtime = (stat($out))[9];
	if ($MAP_TYPE eq 'server') {
		$targ = "${CGI_DIR}/absence-click.pl$inst/${group_id}-${month}-$year";
		print $q->a(
			{ -href => $targ },
			$q->img(
				{
					-src	=> "$in?$modtime",
					-border => 2,
					-ismap	=> undef,
					-width	=> $width,
					-height	=> $height,
				}
			),
		);
		#print qq[<IMG SRC="$in?$modtime" BORDER=2 ISMAP WIDTH="$width" HEIGHT="$height">\n];
	} else {
		$mapname = AbsenceImage::genClientMap($group_id, $month, $year);
		print qq[<IMG SRC="$in?$modtime" BORDER=2 USEMAP="#$mapname" WIDTH="$width" HEIGHT="$height">\n];
	}
	print "<BR>\n";

	if ($month == 12) {
		$year++;
		$month = 1;
	} else {
		$month++;
	}

	$count++;
}

print $q->end_html;

#=====================================================================
# subs
#=====================================================================

sub imageOlder
{
	my ($file, $gid, $month, $year) = @_;

	my $fmt = (stat($file))[9];
	my $smt = AbsenceDB::getModificationTime($gid, $month, $year);

	if (!defined($smt)) { return 1; }

	print "<!-- fmt=[$fmt], smt=[$smt] -->\n";
	if ($fmt < $smt) {
		return 1;
	}
	return 0;
}

sub moveByChunk
{
	my ($month, $year, $mult, $chunksize) = @_;

	my $tmp = $year * 12 + $month;
	$tmp += ($mult * ($chunksize - 1));
	if ($chunksize != 1) { $tmp--; }

	my $m = $tmp % 12 + 1;
	my $y = int($tmp/12);

	($m, $y);
}

__END__

=head1 NAME

absence.pl - heart of web-absence

=head1 DESCRIPTION

C<absence.pl> is responsible for displaying the month-images
in the main frame (below the control frame).  C<absence.pl> gets
the information about groups and months to display first from
C<absence-control.pl> vi CGI, and secondly via cookies (i.e.,
C<absence-control.pl> has precedence).

=cut
